/**
 *
 * ====================================================================================================================================================
 *         "AppWork Utilities" License
 *         The "AppWork Utilities" will be called [The Product] from now on.
 * ====================================================================================================================================================
 *         Copyright (c) 2009-2015, AppWork GmbH <e-mail@appwork.org>
 *         Schwabacher Straße 117
 *         90763 Fürth
 *         Germany
 * === Preamble ===
 *     This license establishes the terms under which the [The Product] Source Code & Binary files may be used, copied, modified, distributed, and/or redistributed.
 *     The intent is that the AppWork GmbH is able to provide their utilities library for free to non-commercial projects whereas commercial usage is only permitted after obtaining a commercial license.
 *     These terms apply to all files that have the [The Product] License header (IN the file), a <filename>.license or <filename>.info (like mylib.jar.info) file that contains a reference to this license.
 *
 * === 3rd Party Licences ===
 *     Some parts of the [The Product] use or reference 3rd party libraries and classes. These parts may have different licensing conditions. Please check the *.license and *.info files of included libraries
 *     to ensure that they are compatible to your use-case. Further more, some *.java have their own license. In this case, they have their license terms in the java file header.
 *
 * === Definition: Commercial Usage ===
 *     If anybody or any organization is generating income (directly or indirectly) by using [The Product] or if there's any commercial interest or aspect in what you are doing, we consider this as a commercial usage.
 *     If your use-case is neither strictly private nor strictly educational, it is commercial. If you are unsure whether your use-case is commercial or not, consider it as commercial or contact us.
 * === Dual Licensing ===
 * === Commercial Usage ===
 *     If you want to use [The Product] in a commercial way (see definition above), you have to obtain a paid license from AppWork GmbH.
 *     Contact AppWork for further details: <e-mail@appwork.org>
 * === Non-Commercial Usage ===
 *     If there is no commercial usage (see definition above), you may use [The Product] under the terms of the
 *     "GNU Affero General Public License" (http://www.gnu.org/licenses/agpl-3.0.en.html).
 *
 *     If the AGPL does not fit your needs, please contact us. We'll find a solution.
 * ====================================================================================================================================================
 * ==================================================================================================================================================== */
package org.appwork.swing.components;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.LayoutManager;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.io.IOException;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollBar;

import org.appwork.app.gui.BasicGui;
import org.appwork.swing.MigPanel;
import org.appwork.swing.synthetica.SyntheticaHelper;
import org.appwork.utils.Application;

/**
 * Source: http://stackoverflow.com/questions/9288350/adding-vertical-scroll-to-a -jpopupmenu
 *
 * @author thomas
 *
 */

public class JScrollPopupMenu extends JPopupMenu {
    protected int maximumVisibleRows = 30;

    public static void main(String[] args) throws IOException {
        Application.setApplication(".appwork");
        SyntheticaHelper.init();
        new BasicGui(JScrollPopupMenu.class.getName()) {

            @Override
            protected void requestExit() {
            }

            @Override
            protected void layoutPanel() {
                final MigPanel panel = new MigPanel("ins 5,wrap 1", "[grow,fill]", "[][grow,fill]");
                getFrame().setContentPane(panel);
                panel.addMouseListener(new MouseListener() {

                    @Override
                    public void mouseReleased(MouseEvent e) {
                    }

                    @Override
                    public void mousePressed(MouseEvent e) {
                    }

                    @Override
                    public void mouseExited(MouseEvent e) {
                    }

                    @Override
                    public void mouseEntered(MouseEvent e) {
                    }

                    @Override
                    public void mouseClicked(MouseEvent e) {
                        JScrollPopupMenu p = new JScrollPopupMenu();
                        JScrollMenu sm = new JScrollMenu("Video");
                        fill(sm);
                        p.add(sm);
                        sm = new JScrollMenu("Audio");
                        fill(sm);
                        p.add(sm);
                        p.show(panel, e.getX(), e.getY());
                    }

                    private void fill(JScrollMenu p) {
                        int i = 1;
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                        p.add(new JMenuItem("a " + (i++)));
                        p.add(new JMenuItem("a " + (i++)));

                    }
                });
            }
        };
    }

    public JScrollPopupMenu() {
        this(null);
    }

    public JScrollPopupMenu(String label) {
        super(label);
        setLayout(new ScrollPopupMenuLayout());

        super.add(getScrollBar());
        addMouseWheelListener(new MouseWheelListener() {
            @Override
            public void mouseWheelMoved(MouseWheelEvent event) {
                JScrollBar scrollBar = getScrollBar();
                int amount = (event.getScrollType() == MouseWheelEvent.WHEEL_UNIT_SCROLL) ? event.getUnitsToScroll() * scrollBar.getUnitIncrement() : (event.getWheelRotation() < 0 ? -1 : 1) * scrollBar.getBlockIncrement();

                scrollBar.setValue(scrollBar.getValue() + amount);
                event.consume();
            }
        });
    }

    private JScrollBar popupScrollBar;

    /*
     * (non-Javadoc)
     *
     * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
     */
    @Override
    protected void paintComponent(Graphics g) {
        // TODO Auto-generated method stub
        super.paintComponent(g);
    }

    protected JScrollBar getScrollBar() {
        if (popupScrollBar == null) {
            popupScrollBar = new JScrollBar(JScrollBar.VERTICAL);
            popupScrollBar.addAdjustmentListener(new AdjustmentListener() {
                @Override
                public void adjustmentValueChanged(AdjustmentEvent e) {
                    doLayout();
                    repaint();
                }
            });

            popupScrollBar.setVisible(false);
        }

        return popupScrollBar;
    }

    public int getMaximumVisibleRows() {
        return maximumVisibleRows;
    }

    public void setMaximumVisibleRows(int maximumVisibleRows) {
        this.maximumVisibleRows = maximumVisibleRows;
    }

    public void paintChildren(Graphics g) {
        Insets insets = getInsets();
        g.clipRect(insets.left, insets.top, getWidth(), getHeight() - insets.top - insets.bottom);
        super.paintChildren(g);
    }

    protected void addImpl(Component comp, Object constraints, int index) {
        super.addImpl(comp, constraints, index);

        if (maximumVisibleRows < getComponentCount() - 1) {
            getScrollBar().setVisible(true);
        }
    }

    public void remove(int index) {
        // can't remove the scrollbar
        ++index;

        super.remove(index);

        if (maximumVisibleRows >= getComponentCount() - 1) {
            getScrollBar().setVisible(false);
        }
    }

    public void show(Component invoker, int x, int y) {
        JScrollBar scrollBar = getScrollBar();
        if (scrollBar.isVisible()) {
            int extent = 0;
            int max = 0;
            int i = 0;
            int unit = -1;
            int width = 0;
            for (Component comp : getComponents()) {
                if (!(comp instanceof JScrollBar)) {
                    Dimension preferredSize = comp.getPreferredSize();
                    width = Math.max(width, preferredSize.width);
                    if (unit < 0) {
                        unit = preferredSize.height;
                    }
                    if (i++ < maximumVisibleRows) {
                        extent += preferredSize.height;
                    }
                    max += preferredSize.height;
                }
            }

            Insets insets = getInsets();
            int widthMargin = insets.left + insets.right;
            int heightMargin = insets.top + insets.bottom;
            scrollBar.setUnitIncrement(unit);
            scrollBar.setBlockIncrement(extent);
            scrollBar.setValues(0, heightMargin + extent, 0, heightMargin + max);

            width += scrollBar.getPreferredSize().width + widthMargin;
            int height = heightMargin + extent;
            if (isPreferredSizeSet()) {
                Dimension pref = getPreferredSize();
                height = Math.max(pref.height, height);
                width = Math.max(pref.width, width);
            }
            setPopupSize(new Dimension(width, height));
        }

        super.show(invoker, x, y);
    }

    protected static class ScrollPopupMenuLayout implements LayoutManager {
        @Override
        public void addLayoutComponent(String name, Component comp) {
        }

        @Override
        public void removeLayoutComponent(Component comp) {
        }

        @Override
        public Dimension preferredLayoutSize(Container parent) {
            int visibleAmount = Integer.MAX_VALUE;
            Dimension dim = new Dimension();
            for (Component comp : parent.getComponents()) {
                if (comp.isVisible()) {
                    if (comp instanceof JScrollBar) {
                        JScrollBar scrollBar = (JScrollBar) comp;
                        visibleAmount = scrollBar.getVisibleAmount();
                    } else {
                        Dimension pref = comp.getPreferredSize();
                        dim.width = Math.max(dim.width, pref.width);
                        dim.height += pref.height;
                    }
                }
            }

            Insets insets = parent.getInsets();
            dim.height = Math.min(dim.height + insets.top + insets.bottom, visibleAmount);

            if (Application.isSyntheticaLookAndFeel()) {
                // workaround for a bug with synthetica.
                dim.width += 10;

            }

            return dim;
        }

        @Override
        public Dimension minimumLayoutSize(Container parent) {
            int visibleAmount = Integer.MAX_VALUE;
            Dimension dim = new Dimension();
            for (Component comp : parent.getComponents()) {
                if (comp.isVisible()) {
                    if (comp instanceof JScrollBar) {
                        JScrollBar scrollBar = (JScrollBar) comp;
                        visibleAmount = scrollBar.getVisibleAmount();
                    } else {
                        Dimension min = comp.getMinimumSize();
                        dim.width = Math.max(dim.width, min.width);
                        dim.height += min.height;
                    }
                }
            }

            Insets insets = parent.getInsets();
            dim.height = Math.min(dim.height + insets.top + insets.bottom, visibleAmount);

            return dim;
        }

        @Override
        public void layoutContainer(Container parent) {
            Insets insets = parent.getInsets();

            int width = parent.getWidth() - insets.left - insets.right;
            int height = parent.getHeight() - insets.top - insets.bottom;

            int x = insets.left;
            int y = insets.top;
            int position = 0;

            for (Component comp : parent.getComponents()) {
                if ((comp instanceof JScrollBar) && comp.isVisible()) {
                    JScrollBar scrollBar = (JScrollBar) comp;
                    Dimension dim = scrollBar.getPreferredSize();
                    scrollBar.setBounds(x + width - dim.width, y, dim.width, height);
                    width -= dim.width;
                    position = scrollBar.getValue();
                }
            }

            y -= position;
            for (Component comp : parent.getComponents()) {
                if (!(comp instanceof JScrollBar) && comp.isVisible()) {
                    Dimension pref = comp.getPreferredSize();
                    comp.setBounds(x, y, width, pref.height);
                    y += pref.height;
                }
            }
        }
    }
}
