/**
 * 
 * ====================================================================================================================================================
 *         "AppWork Utilities" License
 *         The "AppWork Utilities" will be called [The Product] from now on.
 * ====================================================================================================================================================
 *         Copyright (c) 2009-2015, AppWork GmbH <e-mail@appwork.org>
 *         Schwabacher Straße 117
 *         90763 Fürth
 *         Germany   
 * === Preamble ===
 *     This license establishes the terms under which the [The Product] Source Code & Binary files may be used, copied, modified, distributed, and/or redistributed.
 *     The intent is that the AppWork GmbH is able to provide their utilities library for free to non-commercial projects whereas commercial usage is only permitted after obtaining a commercial license.
 *     These terms apply to all files that have the [The Product] License header (IN the file), a <filename>.license or <filename>.info (like mylib.jar.info) file that contains a reference to this license.
 * 	
 * === 3rd Party Licences ===
 *     Some parts of the [The Product] use or reference 3rd party libraries and classes. These parts may have different licensing conditions. Please check the *.license and *.info files of included libraries
 *     to ensure that they are compatible to your use-case. Further more, some *.java have their own license. In this case, they have their license terms in the java file header. 	
 * 	
 * === Definition: Commercial Usage ===
 *     If anybody or any organization is generating income (directly or indirectly) by using [The Product] or if there's any commercial interest or aspect in what you are doing, we consider this as a commercial usage.
 *     If your use-case is neither strictly private nor strictly educational, it is commercial. If you are unsure whether your use-case is commercial or not, consider it as commercial or contact us.
 * === Dual Licensing ===
 * === Commercial Usage ===
 *     If you want to use [The Product] in a commercial way (see definition above), you have to obtain a paid license from AppWork GmbH.
 *     Contact AppWork for further details: <e-mail@appwork.org>
 * === Non-Commercial Usage ===
 *     If there is no commercial usage (see definition above), you may use [The Product] under the terms of the 
 *     "GNU Affero General Public License" (http://www.gnu.org/licenses/agpl-3.0.en.html).
 * 	
 *     If the AGPL does not fit your needs, please contact us. We'll find a solution.
 * ====================================================================================================================================================
 * ==================================================================================================================================================== */
package org.appwork.storage.simplejson.mapper.test;

import java.util.ArrayList;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.appwork.storage.JSonStorage;
import org.appwork.storage.SimpleMapper;
import org.appwork.storage.TypeRef;
import org.appwork.storage.jackson.JacksonMapper;

/**
 * @author Thomas
 * 
 */
public class GenericArrayTest {
    public static void main(final String[] args) {
        final String string = "[[1364860800, 104.000010000000, 104.500000000000, 102.500000000000, 102.500000000000, 1792.511312670000, 185507.020088747854, 103.490013579010], [1364864400, 102.500000000000, 103.700000000000, 102.200000000000, 102.787500000000, 1578.478790170000, 162718.287069765017, 103.085507441149], [1364868000, 102.787500000000, 105.000000000000, 102.900000000000, 104.898950000000, 2278.955862560000, 237732.937713437904, 104.316604642965], [1364871600, 104.898950000000, 105.800000000000, 104.100000000000, 104.720000000000, 2019.867826070000, 212507.561241108027, 105.208647070030], [1364875200, 104.720000000000, 106.000000000000, 103.000010000000, 105.939990000000, 4318.491326270000, 454342.763873898392, 105.208678111744], [1364878800, 105.939990000000, 105.960000000000, 99.000000000000, 102.980000000000, 9735.523419170000, 988094.843994667146, 101.493756570811], [1364882400, 102.980000000000, 103.000000000000, 100.150000000000, 102.798000000000, 2369.749292720000, 241291.782872603640, 101.821649916244], [1364886000, 102.798000000000, 102.999990000000, 101.500000000000, 102.776900000000, 1220.447208270000, 125045.104853921556, 102.458429997291], [1364889600, 102.776900000000, 104.990000000000, 102.000000000000, 104.076000000000, 2632.954577660000, 273425.699581737420, 103.847480659822], [1364893200, 104.076000000000, 105.510000000000, 103.590000000000, 104.449980000000, 2660.127485080000, 278589.376310355663, 104.727828975451], [1364896800, 104.449980000000, 107.121010000000, 103.750000000000, 105.480000000000, 5594.629634490000, 592271.902365445716, 105.864362980202], [1364900400, 105.480000000000, 106.980000000000, 103.760000000000, 106.879000000000, 2152.797223670000, 227727.435587039778, 105.782111330866], [1364904000, 106.879000000000, 108.000000000000, 106.000000000000, 107.979990000000, 1566.858197420000, 168033.448331177416, 107.242281789036], [1364907600, 107.979990000000, 108.000000000000, 107.011000000000, 107.513750000000, 2031.024237960000, 218418.527021578818, 107.541073582146], [1364911200, 107.513750000000, 108.856990000000, 106.951000000000, 108.100000000000, 5628.270849270000, 607817.840602474312, 107.993708348508], [1364914800, 108.100000000000, 108.489000000000, 107.079000000000, 107.080000000000, 1368.659052480000, 147769.359551465524, 107.966523352700], [1364918400, 107.080000000000, 108.370000000000, 107.079000000000, 108.320010000000, 2615.458266470000, 282622.792796865245, 108.058613062220], [1364922000, 108.320010000000, 108.759630000000, 107.800070000000, 108.600000000000, 1714.941194900000, 185845.264774952739, 108.368301681499], [1364925600, 108.600000000000, 110.000000000000, 108.050000000000, 110.000000000000, 7530.546210740000, 821947.788259965528, 109.148495375768], [1364929200, 110.000000000000, 116.000000000000, 109.689000000000, 114.714910000000, 5826.758351460000, 654113.487788397099, 112.260273780617], [1364932800, 114.714910000000, 115.300000000000, 112.000000000000, 113.790000000000, 5578.585586830000, 633252.201922582277, 113.514831325269], [1364936400, 113.790000000000, 116.000000000000, 112.894990000000, 115.420000000000, 3209.145079060000, 368591.803296006448, 114.856696788533], [1364940000, 115.420000000000, 115.660000000000, 113.475000000000, 114.258060000000, 2184.715687310000, 250783.626742264470, 114.790051721123], [1364943600, 114.258060000000, 118.360000000000, 114.258060000000, 117.980000000000, 3651.299117030000, 425831.245250773479, 116.624585278335], [1364947200, 117.980000000000, 118.000000000000, 115.311110000000, 117.598230000000, 2359.496232100000, 276463.623314992130, 117.170614453126], [1364950800, 117.598230000000, 118.387500000000, 115.311110000000, 116.576000000000, 3390.398478800000, 398608.497119590936, 117.569807682510], [1364954400, 116.576000000000, 122.770000000000, 115.776000000000, 121.700000000000, 4603.609435060000, 549849.945898780846, 119.438878048875], [1364958000, 121.700000000000, 127.186700000000, 121.158900000000, 123.400000000000, 6579.451942190000, 816091.501884209320, 124.036395288658], [1364961600, 123.400000000000, 123.870000000000, 117.000000000000, 122.349990000000, 7556.205319220000, 912930.384246117567, 120.818631267732], [1364965200, 122.349990000000, 127.010000000000, 119.478200000000, 127.010000000000, 8356.214240600000, 1028289.096525436434, 123.056813398743], [1364968800, 127.010000000000, 140.000000000000, 124.000000000000, 135.000000000000, 11036.156588850000, 1454088.197895009806, 131.756756637913], [1364972400, 135.000000000000, 144.000000000000, 133.774730000000, 143.799000000000, 8841.946827990000, 1224503.887768816920, 138.488040200891], [1364976000, 143.799000000000, 147.000000000000, 135.000000000000, 139.000000000000, 5388.516809700000, 773069.890032643285, 143.466173964795], [1364979600, 139.000000000000, 139.000000000000, 123.789980000000, 129.889960000000, 11005.697509660000, 1436825.177777471704, 130.552850150236], [1364983200, 129.889960000000, 139.800000000000, 128.010000000000, 138.373910000000, 6761.793398500000, 898074.787844989410, 132.816064454766], [1364986800, 138.373910000000, 141.999900000000, 137.559940000000, 138.005300000000, 5725.403252880000, 799547.845675397523, 139.649175850314], [1364990400, 138.005300000000, 142.000000000000, 138.000000000000, 141.700000000000, 2262.306053250000, 317728.279374771788, 140.444427896185], [1364994000, 141.700000000000, 141.700000000000, 141.000000000000, 141.320010000000, 233.369040420000, 33004.532994722340, 141.426356021018], [1364997600, 141.320010000000, 141.320010000000, 141.320010000000, 141.320010000000, 0.455775390000, 64.410182672554, 141.320010000000], [1365001200, 141.320010000000, 141.960000000000, 130.000000000000, 135.000000000000, 5848.497275650000, 805452.949392311902, 137.719641718187], [1365004800, 135.000000000000, 137.390400000000, 132.000000000000, 133.630100000000, 4562.434102110000, 610948.559295305919, 133.908467634143], [1365008400, 133.630100000000, 138.900000000000, 133.000000000000, 136.601040000000, 5968.249067530000, 816266.207952762387, 136.768120552077], [1365012000, 136.601040000000, 138.700000000000, 115.123000000000, 127.000000000000, 10752.252940840000, 1375196.010747151478, 127.898405879551], [1365015600, 127.000000000000, 133.400000000000, 115.010000000000, 129.900000000000, 2795.403208600000, 348896.203251548556, 124.810689984964], [1365019200, 129.900000000000, 129.900000000000, 114.372290000000, 116.880000000000, 10696.405347920000, 1272425.231137723564, 118.958209767654], [1365022800, 116.880000000000, 129.510000000000, 110.000000000000, 122.792400000000, 11135.217620750000, 1297061.513463057963, 116.482816738672], [1365026400, 122.792400000000, 128.000000000000, 110.010130000000, 123.900000000000, 9045.698283630000, 1072958.951978523059, 118.615381404027], [1365030000, 123.900000000000, 136.000000000000, 120.997050000000, 135.000000000000, 7719.056489810000, 1001313.028141814840, 129.719613979203], [1365033600, 135.000000000000, 135.000000000000, 116.390630000000, 125.140000000000, 7250.699596040000, 922497.630613343408, 127.228775429776], [1365037200, 125.140000000000, 135.500000000000, 121.300000000000, 132.000010000000, 4800.248488460000, 634891.330626386516, 132.262180208523], [1365040800, 132.000010000000, 133.000000000000, 121.000000000000, 123.998990000000, 5626.741152280000, 706215.216896962464, 125.510521593978], [1365044400, 123.998990000000, 126.500000000000, 117.210000000000, 126.500000000000, 6419.607912580000, 776723.903299775589, 120.992421013391], [1365048000, 126.500000000000, 133.000000000000, 126.000000000000, 132.800000000000, 4223.382103410000, 545484.342967159581, 129.158179300597], [1365051600, 132.800000000000, 132.800000000000, 126.690580000000, 129.999010000000, 2989.624906610000, 386920.503060430972, 129.421086305830], [1365055200, 129.999010000000, 135.000000000000, 129.999000000000, 131.950000000000, 2769.712187980000, 367893.182025839308, 132.827224295153], [1365058800, 131.950000000000, 132.980000000000, 130.000000000000, 132.200000000000, 1829.060487140000, 240327.140481920030, 131.393763176037], [1365062400, 132.200000000000, 135.000000000000, 128.312300000000, 133.989000000000, 2862.819349640000, 377247.974052267951, 131.774984020458], [1365066000, 133.989000000000, 134.485000000000, 130.586000000000, 132.111000000000, 2244.132614670000, 297892.041419889790, 132.742619341012], [1365069600, 132.111000000000, 133.500010000000, 131.490010000000, 133.150000000000, 1180.998484550000, 156762.621379927772, 132.737360319018], [1365073200, 133.150000000000, 137.980000000000, 133.000000000000, 137.980000000000, 2186.833572470000, 295693.372802152324, 135.215306973804], [1365076800, 137.980000000000, 142.120000000000, 135.500000000000, 140.500010000000, 7905.197692720000, 1104834.870348176297, 139.760561758706], [1365080400, 140.500010000000, 141.959990000000, 135.017300000000, 135.600000000000, 4067.766923750000, 563470.703640730118, 138.520892224886], [1365084000, 135.600000000000, 137.790000000000, 132.600010000000, 132.600010000000, 3404.486892070000, 460034.306311181393, 135.125885601948], [1365087600, 132.600010000000, 137.700000000000, 132.000000000000, 135.000000000000, 2985.700873300000, 402570.745710149721, 134.832912871543], [1365091200, 135.000000000000, 135.890000000000, 133.330000000000, 135.100000000000, 1529.493623550000, 205620.063865547945, 134.436692444848], [1365094800, 135.100000000000, 135.440000000000, 128.001000000000, 132.559000000000, 9346.833566190000, 1222009.345794597956, 130.740462761093], [1365098400, 132.559000000000, 133.980000000000, 131.000000000000, 133.980000000000, 2165.633469470000, 286873.456565239894, 132.466301712379], [1365102000, 133.980000000000, 134.580000000000, 131.200000000000, 132.500000000000, 2281.756498790000, 303159.433462591834, 132.862307447510], [1365105600, 132.500000000000, 136.000000000000, 131.750000000000, 135.000000000000, 4340.699375850000, 583805.003382312862, 134.495608387529], [1365109200, 135.000000000000, 135.500000000000, 133.000000000000, 133.700000000000, 1362.842109720000, 182701.773859243029, 134.059384103401], [1365112800, 133.700000000000, 134.320000000000, 130.600000000000, 132.990000000000, 3267.273257860000, 431197.511211023808, 131.974731581971], [1365116400, 132.990000000000, 133.000000000000, 131.511850000000, 132.120010000000, 1083.232983890000, 143561.287513032134, 132.530387874166], [1365120000, 132.120010000000, 133.509250000000, 130.243030000000, 131.430010000000, 1532.146072410000, 201483.428098422980, 131.504059388736], [1365123600, 131.430010000000, 132.800000000000, 130.410000000000, 132.800000000000, 1059.434793250000, 139660.790897396737, 131.825754437385], [1365127200, 132.800000000000, 133.320000000000, 131.120000000000, 133.010010000000, 1094.612790480000, 144940.910283729944, 132.412951451236], [1365130800, 133.010010000000, 136.498980000000, 132.300000000000, 136.000000000000, 3349.661504860000, 451591.136229303493, 134.816946600154], [1365134400, 136.000000000000, 138.000000000000, 135.500000000000, 137.000000000000, 4494.736828840000, 616108.493714417801, 137.073318678242], [1365138000, 137.000000000000, 137.998010000000, 135.123450000000, 137.249710000000, 1114.746890880000, 152209.719863660339, 136.541955047305], [1365141600, 137.249710000000, 137.249700000000, 135.810000000000, 136.000000000000, 685.813718030000, 93506.725990760380, 136.344204749007], [1365145200, 136.000000000000, 138.800000000000, 135.810000000000, 138.499990000000, 3111.064789590000, 427127.784558659268, 137.293117773658], [1365148800, 138.499990000000, 139.899980000000, 138.000000000000, 138.880000000000, 2269.744714790000, 315904.891678658216, 139.180802854248], [1365152400, 138.880000000000, 138.880000000000, 135.610000000000, 136.334080000000, 2457.211805670000, 336263.699547438218, 136.847665623090], [1365156000, 136.334080000000, 138.998990000000, 135.500000000000, 136.494680000000, 1982.603288230000, 271724.067241175128, 137.054179650716], [1365159600, 136.494680000000, 138.750000000000, 136.500000000000, 137.740060000000, 1557.663974070000, 214959.191201790134, 138.001003284506], [1365163200, 137.740060000000, 138.680000000000, 136.163240000000, 136.950000000000, 1061.557581230000, 145420.185484818442, 136.987562479959], [1365166800, 136.950000000000, 137.800000000000, 135.120000000000, 136.600010000000, 3272.549585620000, 445465.678482835760, 136.121903374748], [1365170400, 136.600010000000, 137.750000000000, 136.720000000000, 137.000000000000, 1166.390038200000, 159930.305548213530, 137.115630544155], [1365174000, 137.000000000000, 138.600000000000, 136.000000000000, 137.600000000000, 4303.683552570000, 592526.591014380890, 137.678940325560], [1365177600, 137.600000000000, 140.256220000000, 137.600000000000, 140.256220000000, 5247.568335910000, 732293.597628212300, 139.549130330901], [1365181200, 140.256220000000, 144.579900000000, 139.499990000000, 144.000000000000, 9760.846562760000, 1383360.258453058132, 141.725438419544], [1365184800, 144.000000000000, 144.940000000000, 142.000000000000, 142.689630000000, 4331.677626650000, 621559.064903185980, 143.491533414014], [1365188400, 142.689630000000, 144.850000000000, 139.000000000000, 144.000000000000, 6411.129157830000, 909197.972613733688, 141.815575732602], [1365192000, 144.000000000000, 144.500000000000, 141.203000000000, 142.690000000000, 3356.755240820000, 481828.137656537248, 143.539848183520], [1365195600, 142.690000000000, 144.492720000000, 142.002000000000, 142.791000000000, 2199.181566640000, 315371.611932389232, 143.404081189270], [1365199200, 142.791000000000, 144.500000000000, 142.760000000000, 143.000000000000, 1974.988496840000, 283155.310692325994, 143.370612611353], [1365202800, 143.000000000000, 143.500000000000, 142.050000000000, 142.323560000000, 761.733824180000, 108800.603780962622, 142.832837832934], [1365206400, 142.323560000000, 142.999000000000, 141.500000000000, 142.749990000000, 742.049229530000, 105611.263535947063, 142.323796499107], [1365210000, 142.749990000000, 142.749990000000, 139.540000000000, 140.949000000000, 2614.865670680000, 367467.864021059241, 140.530302623729], [1365213600, 140.949000000000, 142.000000000000, 140.000100000000, 141.346860000000, 543.108940890000, 76707.023483100868, 141.236900569893], [1365217200, 141.346860000000, 142.990000000000, 140.000100000000, 142.500000000000, 890.985825740000, 126384.872077287231, 141.848353168042], [1365220800, 142.500000000000, 142.990000000000, 139.550000000000, 141.608790000000, 1466.261384810000, 207054.973814259237, 141.212866927604], [1365224400, 141.608790000000, 142.990000000000, 140.498790000000, 142.500010000000, 433.877802000000, 61497.064168740681, 141.738212660948], [1365228000, 142.500010000000, 143.500000000000, 142.499980000000, 143.500000000000, 567.894519590000, 81068.286107303432, 142.752365643239], [1365231600, 143.500000000000, 143.900000000000, 141.781710000000, 141.796070000000, 1698.204457760000, 242580.896760385979, 142.845518778322], [1365235200, 141.796070000000, 142.600000000000, 141.600000000000, 142.000000000000, 448.084094440000, 63758.358250742922, 142.291054384392], [1365238800, 142.000000000000, 142.500000000000, 141.600000000000, 142.497000000000, 186.362615030000, 26461.361601984190, 141.988572105648], [1365242400, 142.497000000000, 142.500000000000, 141.620000000000, 142.497010000000, 484.184265720000, 68921.700000971239, 142.346013451061], [1365246000, 142.497010000000, 142.600000000000, 141.600000000000, 141.721010000000, 495.423713010000, 70285.462264410911, 141.869394658936], [1365249600, 141.721010000000, 142.200000000000, 141.420000000000, 142.000000000000, 331.798560450000, 47021.569114076189, 141.717218574738], [1365253200, 142.000000000000, 142.000000000000, 141.100000000000, 142.000000000000, 599.553387720000, 84811.601605359546, 141.457964115395], [1365256800, 142.000000000000, 143.200000000000, 141.310000000000, 143.200000000000, 849.407022860000, 120854.123689939869, 142.280579789672], [1365260400, 143.200000000000, 143.870000000000, 143.000000000000, 143.000000000000, 1064.249229200000, 152565.767609069684, 143.355300077364], [1365264000, 143.000000000000, 143.500000000000, 142.803000000000, 143.250000000000, 382.487815960000, 54757.902371167176, 143.162474950297], [1365267600, 143.250000000000, 143.500000000000, 142.298010000000, 142.300010000000, 741.071121080000, 105890.076639232627, 142.887873548376], [1365271200, 142.300010000000, 143.490000000000, 142.010000000000, 143.000000000000, 660.323880660000, 94229.588370679588, 142.702075648841], [1365274800, 143.000000000000, 143.480000000000, 142.100000000000, 143.479990000000, 492.392037620000, 70316.373071941246, 142.805666419422], [1365278400, 143.479990000000, 143.479980000000, 142.490000000000, 143.000010000000, 460.625861550000, 65812.277877919478, 142.875777005794], [1365282000, 143.000010000000, 143.650000000000, 142.500000000000, 143.500010000000, 656.541711680000, 94080.639904508433, 143.297277584647], [1365285600, 143.500010000000, 143.500010000000, 142.760000000000, 142.770010000000, 506.951371160000, 72569.139096374582, 143.148126674010], [1365289200, 142.770010000000, 143.889000000000, 142.510000000000, 142.631120000000, 956.382087090000, 136957.261479703367, 143.203499237868], [1365292800, 142.631120000000, 144.000000000000, 142.631130000000, 144.000000000000, 1237.294482850000, 177504.886457424161, 143.462117481165], [1365296400, 144.000000000000, 144.000000000000, 142.721100000000, 143.600010000000, 769.131502000000, 110352.019961708328, 143.476141173201], [1365300000, 143.600010000000, 144.500000000000, 143.010000000000, 144.001000000000, 898.335925080000, 129336.192129588134, 143.973082361223], [1365303600, 144.001000000000, 144.500000000000, 143.500000000000, 144.249980000000, 866.312449140000, 124917.389908229071, 144.194383945696], [1365307200, 144.249980000000, 144.500000000000, 143.500000000000, 144.500000000000, 427.707412260000, 61656.313680230242, 144.155354601968], [1365310800, 144.500000000000, 144.500000000000, 144.110000000000, 144.260010000000, 266.860804480000, 38517.103417070701, 144.334060193382], [1365314400, 144.260010000000, 144.900000000000, 144.260010000000, 144.900000000000, 989.249360630000, 143009.298824936763, 144.563448323951], [1365318000, 144.900000000000, 144.999800000000, 144.550000000000, 144.979990000000, 775.014717390000, 112267.358874058515, 144.858357338218], [1365321600, 144.979990000000, 146.300000000000, 143.010000000000, 146.289980000000, 3892.355699470000, 563457.470972584355, 144.760015393585], [1365325200, 146.289980000000, 148.990000000000, 146.000010000000, 147.020000000000, 3588.327317110000, 530501.891110223608, 147.840997832239], [1365328800, 147.020000000000, 148.980000000000, 147.010000000000, 148.100000000000, 1192.285587370000, 176463.540238276977, 148.004422856045], [1365332400, 148.100000000000, 154.000000000000, 148.010000000000, 153.300000000000, 7153.515751540000, 1073160.250524735337, 150.018576571067], [1365336000, 153.300000000000, 157.000000000000, 151.440000000000, 154.899990000000, 4218.127826210000, 648790.896630877141, 153.810155443729], [1365339600, 154.899990000000, 157.500000000000, 153.750000000000, 156.600000000000, 1567.254882340000, 244032.776714241867, 155.707140851198], [1365343200, 156.600000000000, 159.000000000000, 154.602770000000, 158.470000000000, 2877.511181360000, 450761.928997803800, 156.649931342668], [1365346800, 158.470000000000, 160.000000000000, 156.010000000000, 160.000000000000, 2929.459240460000, 464495.630655230744, 158.560195765787], [1365350400, 160.000000000000, 162.900000000000, 152.250000000000, 156.899990000000, 7660.254916770000, 1207864.261919287077, 157.679382088839], [1365354000, 156.899990000000, 159.969000000000, 153.111110000000, 158.210000000000, 5447.515126750000, 855449.412352385941, 157.034793377939], [1365357600, 158.210000000000, 162.499990000000, 157.625010000000, 158.000000000000, 3448.555652280000, 553150.999744209570, 160.400775141470], [1365361200, 158.000000000000, 160.000000000000, 157.000000000000, 159.600000000000, 1366.073934780000, 216530.897503463259, 158.505987114332], [1365364800, 159.600000000000, 162.700000000000, 157.815980000000, 162.700000000000, 2120.526975580000, 340702.297933739709, 160.668693139615], [1365368400, 162.700000000000, 164.900000000000, 161.000000000000, 163.500000000000, 4269.426936120000, 696058.469859946761, 163.033231455769], [1365372000, 163.500000000000, 163.499990000000, 160.000000000000, 162.280000000000, 2041.969082050000, 328937.840458495047, 161.088550923731], [1365375600, 162.280000000000, 163.840000000000, 161.293780000000, 162.301020000000, 944.450760550000, 153549.205385703487, 162.580424305322], [1365379200, 162.301020000000, 169.500000000000, 162.598060000000, 168.999710000000, 3430.725337780000, 568327.582641392522, 165.658141263256], [1365382800, 168.999710000000, 174.419990000000, 168.000000000000, 170.500010000000, 7318.279859940000, 1256058.063219718608, 171.632963928496], [1365386400, 170.500010000000, 174.470000000000, 169.955450000000, 173.000000000000, 3061.758539430000, 529187.808264563272, 172.837864726942], [1365390000, 173.000000000000, 173.880000000000, 166.693460000000, 168.797830000000, 3649.179207840000, 622374.004081396133, 170.551778532627], [1365393600, 168.797830000000, 172.990000000000, 167.000000000000, 171.110030000000, 3325.705048500000, 562707.988560735893, 169.199607407920], [1365397200, 171.110030000000, 173.950000000000, 170.877750000000, 173.700000000000, 1804.168839180000, 312527.818613001701, 173.225372163642], [1365400800, 173.700000000000, 174.927580000000, 172.000000000000, 173.890000000000, 2298.587242000000, 399093.078741733561, 173.625377992824], [1365404400, 173.890000000000, 180.000000000000, 172.250000000000, 180.000000000000, 5276.718306940000, 934245.781150236630, 177.050531562677], [1365408000, 180.000000000000, 184.000000000000, 179.323020000000, 181.500000000000, 4292.298390460000, 781869.966706006136, 182.156480184085], [1365411600, 181.500000000000, 186.500000000000, 180.060000000000, 185.000000000000, 3173.003659780000, 586413.218761099781, 184.813281558509], [1365415200, 185.000000000000, 186.300000000000, 178.500000000000, 181.509990000000, 4629.437513370000, 842346.638276765522, 181.954424450926], [1365418800, 181.509990000000, 184.980000000000, 181.000000000000, 183.400000000000, 3101.255019520000, 567978.870087895555, 183.144845074948], [1365422400, 183.400000000000, 191.000000000000, 182.500000000000, 190.399990000000, 6506.055180750000, 1221942.243531743841, 187.816151198226], [1365426000, 190.399990000000, 190.550000000000, 187.550000000000, 189.990000000000, 3218.238391620000, 609224.643170559129, 189.303764679747], [1365429600, 189.990000000000, 194.900000000000, 188.300000000000, 194.900000000000, 5280.658592440000, 1016971.682896838912, 192.584251584220], [1365433200, 194.900000000000, 194.900000000000, 180.000000000000, 186.960000000000, 6062.643009390000, 1124952.047479036002, 185.554723531746], [1365436800, 186.960000000000, 190.000000000000, 172.130000000000, 186.100000000000, 14144.917427520000, 2549010.944026731386, 180.206845115083], [1365440400, 186.100000000000, 188.000000000000, 178.001000000000, 183.400000000000, 5519.234943990000, 1005667.034589548356, 182.211310950739], [1365444000, 183.400000000000, 189.900000000000, 182.000000000000, 185.980000000000, 5209.928200910000, 968608.043881472855, 185.915814293235], [1365447600, 185.980000000000, 190.997770000000, 185.000000000000, 190.997770000000, 4120.941821360000, 774173.021118954848, 187.863128061211], [1365451200, 190.997770000000, 192.806000000000, 187.800010000000, 187.800010000000, 4038.446547510000, 769341.090462905726, 190.504215274871], [1365454800, 187.800010000000, 189.990000000000, 180.000000000000, 187.999990000000, 10035.090921460000, 1842301.341684040937, 183.585914278493], [1365458400, 187.999990000000, 190.950000000000, 185.600000000000, 186.000000000000, 2547.369272690000, 481206.613175278600, 188.903359373228], [1365462000, 186.000000000000, 187.500000000000, 184.582000000000, 187.500000000000, 2081.869524370000, 386633.588812914918, 185.714610972037], [1365465600, 187.500000000000, 190.499990000000, 186.500000000000, 189.000000000000, 1308.546112710000, 246921.577671123497, 188.699179396704], [1365469200, 189.000000000000, 190.880000000000, 188.500010000000, 190.500010000000, 1269.127366120000, 240814.939100403625, 189.748440959576], [1365472800, 190.500010000000, 192.900000000000, 190.000000000000, 191.009990000000, 2383.582188360000, 454878.117526185351, 190.838025115115], [1365476400, 191.009990000000, 192.905000000000, 191.000000000000, 191.900010000000, 1963.416016240000, 376213.585649531382, 191.611753463228], [1365480000, 191.900010000000, 193.000000000000, 187.000000000000, 192.600000000000, 3664.664790050000, 701738.526083079894, 191.487780270759], [1365483600, 192.600000000000, 194.000000000000, 190.200000000000, 191.550010000000, 2643.593461900000, 509643.164447578914, 192.784243036102], [1365487200, 191.550010000000, 192.419350000000, 190.500000000000, 191.647180000000, 1162.580068920000, 222324.978215760840, 191.234121553704], [1365490800, 191.647180000000, 194.000000000000, 189.601230000000, 190.000000000000, 2098.410720450000, 402578.592669518060, 191.849283243838], [1365494400, 190.000000000000, 194.200000000000, 189.601230000000, 194.199800000000, 1866.153198820000, 360823.279762619221, 193.351371147221], [1365498000, 194.199800000000, 194.500000000000, 193.000010000000, 194.400000000000, 1866.745189790000, 362772.357442809399, 194.334159491591], [1365501600, 194.400000000000, 202.480000000000, 193.840000000000, 202.000010000000, 11074.195178660000, 2195117.382906315254, 198.219134437536], [1365505200, 202.000010000000, 207.000000000000, 199.700000000000, 204.130000000000, 6023.249295900000, 1226370.822384747143, 203.606186982752], [1365508800, 204.130000000000, 210.000000000000, 202.293430000000, 209.750000000000, 5829.790636770000, 1203805.585999660818, 206.492078533138], [1365512400, 209.750000000000, 211.000000000000, 205.000000000000, 211.000000000000, 4794.647625510000, 999858.158813193166, 208.536317349670], [1365516000, 211.000000000000, 219.980000000000, 209.700000000000, 219.120000000000, 6467.667615600000, 1395567.622181146595, 215.776027020164], [1365519600, 219.120000000000, 224.670000000000, 213.000000000000, 221.010000000000, 8959.634146840000, 1966261.155730828269, 219.457750562763], [1365523200, 221.010000000000, 227.860180000000, 221.030000000000, 224.990000000000, 5385.733645380000, 1210726.166952153421, 224.802458991031], [1365526800, 224.990000000000, 239.111000000000, 220.000000000000, 236.800000000000, 9242.095746880000, 2122964.709060180005, 229.705985222763], [1365530400, 236.800000000000, 240.111000000000, 230.000000000000, 230.000000000000, 6837.034857530000, 1615556.380529828116, 236.294887212770], [1365534000, 230.000000000000, 237.980000000000, 230.000000000000, 233.000000000000, 5210.872675230000, 1218069.696203439517, 233.755413367431], [1365537600, 233.000000000000, 236.600000000000, 232.000000000000, 235.110070000000, 2373.752736430000, 556429.194798993726, 234.409079875705], [1365541200, 235.110070000000, 238.000000000000, 234.110000000000, 235.415700000000, 2580.473922530000, 609459.885964535397, 236.181377631205], [1365544800, 235.415700000000, 237.490000000000, 232.000000000000, 232.001000000000, 6906.480884020000, 1616272.461165466744, 234.022577968057], [1365548400, 232.001000000000, 234.890000000000, 228.000000000000, 230.000000000000, 3812.189185410000, 881114.192510994637, 231.130762314523], [1365552000, 230.000000000000, 235.000000000000, 227.012300000000, 234.300000000000, 3610.049284760000, 832203.445041980056, 230.524122912994], [1365555600, 234.300000000000, 235.490000000000, 231.000000000000, 233.591790000000, 2135.050640700000, 497649.188198357795, 233.085426037107], [1365559200, 233.591790000000, 235.890000000000, 231.777000000000, 235.000000000000, 1648.976461070000, 386837.218868596083, 234.592323178211], [1365562800, 235.000000000000, 235.878000000000, 231.600000000000, 234.890000000000, 1527.297386770000, 356938.857943319407, 233.706193067082], [1365566400, 234.890000000000, 234.890000000000, 230.000000000000, 231.500100000000, 2355.974697940000, 544915.925278918690, 231.291077003237], [1365570000, 231.500100000000, 234.900000000000, 231.500000000000, 232.000000000000, 959.089778090000, 223975.131188138354, 233.528848189977], [1365573600, 232.000000000000, 234.887000000000, 230.500000000000, 234.249990000000, 968.786293170000, 225112.971704345036, 232.365975129298], [1365577200, 234.249990000000, 239.000000000000, 233.000010000000, 235.000010000000, 3271.747796050000, 773287.264464814305, 236.352956483507], [1365580800, 235.000010000000, 238.678000000000, 232.000000000000, 235.999990000000, 2257.802215530000, 530412.866879886628, 234.924415979181], [1365584400, 235.999990000000, 249.879990000000, 235.999990000000, 249.879900000000, 4841.101206700000, 1182558.548880531806, 244.274700814743], [1365588000, 249.879900000000, 250.000000000000, 244.400000000000, 249.990000000000, 3403.842207030000, 847803.851440307562, 249.072606741090], [1365591600, 249.990000000000, 255.533400000000, 244.000000000000, 255.010000000000, 3149.994984820000, 788822.086906167922, 250.420108827965], [1365595200, 255.010000000000, 266.000000000000, 255.000000000000, 263.479990000000, 4081.496918830000, 1067846.206409146372, 261.631021080191], [1365598800, 263.479990000000, 263.798000000000, 244.000000000000, 246.000000000000, 6502.149604220000, 1662614.962784841266, 255.702354449946], [1365602400, 246.000000000000, 258.500000000000, 241.000000000000, 252.100000000000, 5894.266416550000, 1474587.838773340737, 250.173258988256], [1365606000, 252.100000000000, 255.000000000000, 236.000000000000, 236.000000000000, 4844.831343380000, 1181191.889085983265, 243.804542484223], [1365609600, 236.000000000000, 239.985000000000, 217.111000000000, 221.000000000000, 7737.029232510000, 1764165.347903657358, 228.015856588839], [1365613200, 221.000000000000, 221.000000000000, 184.468290000000, 184.468290000000, 10578.242490290000, 2154347.203388805111, 203.658330329100], [1365616800, 184.468290000000, 200.000000000000, 126.000000000000, 126.000000000000, 16878.375368810000, 2662051.695769157195, 157.719664221263], [1365620400, 126.000000000000, 185.000000000000, 105.000000000000, 139.450000000000, 20510.695434780000, 2677881.936368362875, 130.560270122654], [1365624000, 139.450000000000, 189.890000000000, 120.000000000000, 184.940000000000, 24000.245096950000, 3739103.775437313598, 155.794399612714], [1365627600, 184.940000000000, 203.000000000000, 150.000000000000, 150.000000000000, 23056.281855780000, 4145875.437771270699, 179.815438746987], [1365631200, 150.000000000000, 178.750000000000, 125.000000000000, 150.000000000000, 23181.748683340000, 3344823.493104767781, 144.286936192548], [1365634800, 150.000000000000, 174.000000000000, 142.111110000000, 165.000000000000, 12746.780289290000, 2044356.270375558518, 160.382168985312], [1365638400, 165.000000000000, 188.700000000000, 163.000000000000, 179.736210000000, 13254.499422970000, 2361728.314517267412, 178.183139110060], [1365642000, 179.736210000000, 180.000000000000, 165.000010000000, 168.000000000000, 6968.810906850000, 1205260.576002651396, 172.950678690096], [1365645600, 168.000000000000, 170.000000000000, 149.000000000000, 165.625000000000, 11751.635005220000, 1849237.438065113996, 157.360013074240], [1365649200, 165.625000000000, 172.100000000000, 156.700000000000, 168.000000000000, 8356.051409470000, 1400238.284324808615, 167.571765144707], [1365652800, 168.000000000000, 178.987650000000, 167.700010000000, 169.500000000000, 4895.230643680000, 849029.855939788804, 173.440215127745], [1365656400, 169.500000000000, 179.700000000000, 166.790010000000, 174.000000000000, 5402.027489220000, 941006.203003697737, 174.195004538855], [1365660000, 174.000000000000, 188.700000000000, 173.000000000000, 181.000000000000, 10073.844426250000, 1832255.732080775382, 181.882472525222], [1365663600, 181.000000000000, 183.700000000000, 172.300000000000, 177.900000000000, 4683.498370420000, 839258.120103750410, 179.194707401700], [1365667200, 177.900000000000, 181.220000000000, 163.400000000000, 163.400000000000, 7220.589139750000, 1222083.807423860221, 169.249874736146], [1365670800, 163.400000000000, 164.600000000000, 143.000000000000, 146.765000000000, 7300.573648360000, 1133520.508266092582, 155.264580958063], [1365674400, 146.765000000000, 156.000000000000, 140.435130000000, 152.998470000000, 2586.001391380000, 377812.881055050276, 146.099256680381], [1365678000, 152.998470000000, 168.000000000000, 140.435130000000, 163.000000000000, 4774.520320460000, 746859.858270005111, 156.426155538500], [1365681600, 163.000000000000, 163.800000000000, 144.200000000000, 146.000000000000, 5405.806124960000, 829049.785421860318, 153.362841037514], [1365685200, 146.000000000000, 146.500000000000, 110.200030000000, 110.200030000000, 23852.273020620000, 3021223.623193727573, 126.663971210707], [1365688800, 110.200030000000, 123.400980000000, 110.200030000000, 120.000000000000, 2097.710876240000, 244520.083763558091, 116.565198060966], [1365692400, 120.000000000000, 120.000000000000, 120.000000000000, 120.000000000000, 0, 0, 120.000000000000], [1365696000, 120.000000000000, 123.400980000000, 123.400980000000, 123.400980000000, 4.397079500000, 542.603919437910, 123.400980000000], [1365699600, 123.400980000000, 123.400980000000, 123.400980000000, 123.400980000000, 13.375330790000, 1650.528927310174, 123.400980000000], [1365703200, 123.400980000000, 123.400980000000, 123.400980000000, 123.400980000000, 0, 0, 123.400980000000], [1365706800, 123.400980000000, 124.900000000000, 123.400980000000, 124.900000000000, 4.580853480000, 568.609464124916, 124.127406957560], [1365710400, 124.900000000000, 124.900000000000, 124.900000000000, 124.900000000000, 0, 0, 124.900000000000], [1365714000, 124.900000000000, 124.900000000000, 124.900000000000, 124.900000000000, 0, 0, 124.900000000000], [1365717600, 124.900000000000, 124.900000000000, 124.900000000000, 124.900000000000, 0, 0, 124.900000000000], [1365721200, 124.900000000000, 124.900000000000, 124.900000000000, 124.900000000000, 0, 0, 124.900000000000], [1365724800, 124.900000000000, 124.900000000000, 124.900000000000, 124.900000000000, 0, 0, 124.900000000000], [1365728400, 124.900000000000, 130.010000000000, 118.800000000000, 130.010000000000, 286.880684850000, 36657.073780780325, 127.778117233466], [1365732000, 130.010000000000, 140.000000000000, 65.000000000000, 124.927840000000, 51691.967227860000, 4826512.748382538661, 93.370653260440], [1365735600, 124.927840000000, 131.000000000000, 92.100000000000, 110.999990000000, 25520.808190480000, 2794504.160026752006, 109.499046392629], [1365739200, 110.999990000000, 110.999990000000, 110.999980000000, 110.999990000000, 23.956054130000, 2659.121742437148, 110.999988896633], [1365742800, 110.999990000000, 111.000000000000, 86.000000000000, 93.400000000000, 12880.086667960000, 1178280.027561316793, 91.480753036574], [1365746400, 93.400000000000, 109.999000000000, 91.000000000000, 97.690000000000, 22702.023213610000, 2335302.342241936421, 102.867586746273], [1365750000, 97.690000000000, 99.990000000000, 82.000000000000, 93.036910000000, 35635.045075140000, 3303146.979783657470, 92.693778633327], [1365753600, 93.036910000000, 95.010000000000, 87.129510000000, 89.939990000000, 13031.250133850000, 1184462.139602738427, 90.893976206164], [1365757200, 89.939990000000, 92.784100000000, 86.012300000000, 86.500000000000, 12597.305067410000, 1131017.012631138135, 89.782457960564], [1365760800, 86.500000000000, 90.110000000000, 76.110000000000, 77.000000000000, 32079.284493710000, 2583755.356643641355, 80.542798800586], [1365764400, 77.000000000000, 86.130000000000, 67.600480000000, 67.600480000000, 38848.440066990000, 2931639.022687493238, 75.463493968669], [1365768000, 67.600480000000, 79.999900000000, 54.250000000000, 77.000000000000, 69214.700317420000, 4431718.890159830398, 64.028578753298], [1365771600, 77.000000000000, 78.000000000000, 66.000000000000, 77.000000000000, 23754.480380560000, 1704164.840372730088, 71.740775343054], [1365775200, 77.000000000000, 83.400000000000, 71.000000000000, 73.210420000000, 27100.284398760000, 2096501.786203549594, 77.360877670327], [1365778800, 73.210420000000, 75.900000000000, 68.330000000000, 70.280000000000, 19034.748411890000, 1370692.733053243914, 72.010026263181], [1365782400, 70.280000000000, 76.000000000000, 67.344530000000, 72.950000000000, 19492.157227220000, 1399928.714510320269, 71.820101705078], [1365786000, 72.950000000000, 76.888000000000, 72.001600000000, 75.200000000000, 10409.083865880000, 778753.596101315140, 74.814806580048], [1365789600, 75.200000000000, 79.990000000000, 75.100000000000, 79.000000000000, 12184.787979600000, 942636.817589765370, 77.361774301526], [1365793200, 79.000000000000, 89.990000000000, 77.000000000000, 89.990000000000, 23292.751677230000, 1962327.786209397947, 84.246284569619], [1365796800, 89.990000000000, 96.000000000000, 85.000000000000, 88.000000000000, 26499.091926680000, 2403962.571377441200, 90.718677380679], [1365800400, 88.000000000000, 106.000000000000, 87.000000000000, 102.306180000000, 25416.567231340000, 2449241.235478860850, 96.363966588644], [1365804000, 102.306180000000, 113.900000000000, 96.210000000000, 111.300000000000, 33358.299137780000, 3400871.210919757050, 101.949778580530], [1365807600, 111.300000000000, 117.000000000000, 102.300000000000, 117.000000000000, 21235.097243070000, 2352047.128398173429, 110.762249001038], [1365811200, 117.000000000000, 130.000000000000, 114.432000000000, 122.190000000000, 31709.462504200000, 3888757.927576372108, 122.637144261316], [1365814800, 122.190000000000, 125.000000000000, 102.723930000000, 111.000000000000, 21386.053016160000, 2392609.328029045989, 111.877087661810], [1365818400, 111.000000000000, 114.700050000000, 98.010000000000, 102.820010000000, 10568.401332830000, 1099211.858624639933, 104.009284281248], [1365822000, 102.820010000000, 104.070000000000, 98.010000000000, 100.950000000000, 971.405168560000, 96008.251750888366, 98.834404899461], [1365825600, 100.950000000000, 116.910000000000, 98.010000000000, 107.990000000000, 15939.070627310000, 1760900.799381606985, 110.477005877901], [1365829200, 107.990000000000, 113.743460000000, 104.110000000000, 108.960000000000, 9383.948241410000, 1030935.802839967738, 109.861625013083], [1365832800, 108.960000000000, 112.000000000000, 108.500000000000, 109.250000000000, 8513.665830920000, 935567.203694486796, 109.890054680874], [1365836400, 109.250000000000, 124.112980000000, 109.241950000000, 118.839450000000, 13731.995423940000, 1612080.728726923262, 117.395955864977], [1365840000, 118.839450000000, 122.000000000000, 111.500000000000, 114.990000000000, 14051.089744650000, 1650509.138461227809, 117.464849236314], [1365843600, 114.990000000000, 117.900000000000, 110.110000000000, 114.000000000000, 7766.756291100000, 887571.119211215110, 114.278224518039], [1365847200, 114.000000000000, 117.000000000000, 113.000000000000, 116.000000000000, 5721.420078590000, 660391.796436569915, 115.424455356426], [1365850800, 116.000000000000, 117.500000000000, 115.999900000000, 117.050000000000, 4665.092320220000, 544993.065732625343, 116.823639988956], [1365854400, 117.050000000000, 117.889990000000, 115.200000000000, 116.350000000000, 4189.197265940000, 489150.429191925588, 116.764716039737], [1365858000, 116.350000000000, 116.890000000000, 114.000000000000, 114.135000000000, 5078.610160350000, 587296.648659892581, 115.641214843594], [1365861600, 114.135000000000, 116.333300000000, 111.300000000000, 114.500000000000, 6955.790674160000, 789294.664916757257, 113.473033029717], [1365865200, 114.500000000000, 115.800000000000, 113.598830000000, 114.902000000000, 3112.128629430000, 357039.615463415148, 114.725211576107], [1365868800, 114.902000000000, 115.500000000000, 113.105000000000, 114.400000000000, 6342.808560920000, 726077.770601664712, 114.472597371968], [1365872400, 114.400000000000, 114.589000000000, 110.000000000000, 111.000000000000, 7361.315548310000, 831764.478837698043, 112.991281704892], [1365876000, 111.000000000000, 111.970000000000, 105.810880000000, 108.000000000000, 3729.731800450000, 403875.286184542862, 108.285342698318], [1365879600, 108.000000000000, 108.000000000000, 95.899990000000, 101.000000000000, 7481.387130200000, 759879.723400202680, 101.569362763331], [1365883200, 101.000000000000, 101.675080000000, 86.520000000000, 99.999990000000, 10250.998721250000, 945984.920728005731, 92.282220147683], [1365886800, 99.999990000000, 100.500000000000, 85.500000000000, 100.500000000000, 16663.063381530000, 1540420.100427118642, 92.445192408893], [1365890400, 100.500000000000, 107.000000000000, 97.074120000000, 99.497530000000, 12109.436960790000, 1229190.253317551538, 101.506804758771], [1365894000, 99.497530000000, 102.980000000000, 92.031000000000, 93.000000000000, 10543.493799250000, 1034928.304441903744, 98.158003802831], [1365897600, 93.000000000000, 96.980000000000, 90.150000000000, 93.500000000000, 11396.796194800000, 1059995.414870990914, 93.008192544027], [1365901200, 93.500000000000, 100.990000000000, 93.498490000000, 98.100000000000, 9289.423226940000, 904333.202266139360, 97.350845168030], [1365904800, 98.100000000000, 102.200000000000, 95.000000000000, 98.690000000000, 9762.318101610000, 970752.426942582931, 99.438721094582], [1365908400, 98.690000000000, 102.500000000000, 97.250000000000, 102.500000000000, 5029.527599060000, 504404.795617069262, 100.288702205619], [1365912000, 102.500000000000, 106.519420000000, 101.001000000000, 105.719990000000, 4203.976463630000, 435305.922757825897, 103.546232126607], [1365915600, 105.719990000000, 107.899990000000, 102.000000000000, 103.999980000000, 5234.107968390000, 550757.343983347313, 105.224681513927], [1365919200, 103.999980000000, 105.500000000000, 100.020000000000, 104.337000000000, 6365.121009020000, 651994.732188318434, 102.432417429987], [1365922800, 104.337000000000, 109.998000000000, 100.830300000000, 105.340000000000, 9658.306244270000, 1019331.300355678602, 105.539343501395], [1365926400, 105.340000000000, 106.449460000000, 99.322540000000, 100.000000000000, 13858.808174870000, 1412395.757621038976, 101.913219361974], [1365930000, 100.000000000000, 103.000000000000, 98.472150000000, 99.650000000000, 4980.002831800000, 498309.705228830374, 100.062132906201], [1365933600, 99.650000000000, 102.884920000000, 98.102000000000, 100.700010000000, 3240.613134820000, 324714.750470330472, 100.201639924652], [1365937200, 100.700010000000, 105.400000000000, 100.425000000000, 104.000000000000, 5501.625026210000, 572474.778409827449, 104.055579157527], [1365940800, 104.000000000000, 104.450000000000, 99.860000000000, 101.700000000000, 3783.539171020000, 382613.732499997247, 101.125881140765], [1365944400, 101.700000000000, 102.000000000000, 98.950000000000, 99.500000000000, 3479.479172840000, 348405.173192020041, 100.131415043835], [1365948000, 99.500000000000, 100.570000000000, 98.995000000000, 100.500000000000, 2582.806804740000, 257189.531071756143, 99.577533480150], [1365951600, 100.500000000000, 100.940000000000, 99.000000000000, 99.200000000000, 1971.620740250000, 196844.019126316438, 99.838683529651], [1365955200, 99.200000000000, 100.940000000000, 99.010000000000, 100.222050000000, 2304.120152080000, 230840.243819114041, 100.185853420329], [1365958800, 100.222050000000, 100.890000000000, 99.900000000000, 100.000000000000, 1455.584285590000, 145996.728748960500, 100.301116324420], [1365962400, 100.000000000000, 100.869990000000, 99.133700000000, 99.800000000000, 2500.623754630000, 250332.204789589438, 100.107904808186], [1365966000, 99.800000000000, 100.240000000000, 94.500000000000, 96.478890000000, 8622.744715490000, 836734.886148364383, 97.038114168595], [1365969600, 96.478890000000, 99.000000000000, 92.000000000000, 96.200000000000, 12405.790238400000, 1176999.170455535282, 94.874985618597], [1365973200, 96.200000000000, 97.900000000000, 95.000000000000, 95.000000000000, 2253.747004160000, 216959.422404185567, 96.266094643151], [1365976800, 95.000000000000, 96.720540000000, 89.404750000000, 91.000010000000, 12261.564340560000, 1130303.436048302342, 92.182645268954], [1365980400, 91.000010000000, 92.000000000000, 84.436890000000, 89.999990000000, 24125.216368210000, 2117903.876598019013, 87.787974386369], [1365984000, 89.999990000000, 97.583760000000, 87.000000000000, 90.010110000000, 9131.479778820000, 836781.856091637247, 91.637048579192], [1365987600, 90.010110000000, 96.133700000000, 90.000010000000, 94.999990000000, 6216.576104930000, 588037.576587012314, 94.591872867232], [1365991200, 94.999990000000, 97.000000000000, 91.300000000000, 95.979990000000, 3901.278126670000, 369399.299803558162, 94.686737989343], [1365994800, 95.979990000000, 96.000000000000, 93.875590000000, 94.000000000000, 3819.644739980000, 361969.887577743822, 94.765328248731], [1365998400, 94.000000000000, 95.190000000000, 93.000000000000, 94.390000000000, 2897.733751940000, 272234.302927597605, 93.947314084788], [1366002000, 94.390000000000, 97.990000000000, 94.300000000000, 97.300000000000, 4625.521783640000, 445255.008392187006, 96.260493241435], [1366005600, 97.300000000000, 102.000000000000, 97.001000000000, 100.500000000000, 11879.152216110000, 1180191.376750853243, 99.349798308867], [1366009200, 100.500000000000, 101.900000000000, 96.510000000000, 100.200010000000, 7938.758905140000, 786732.231028457304, 99.100154120952], [1366012800, 100.200010000000, 100.330000000000, 97.800000000000, 99.480000000000, 1958.763225590000, 194238.504680976257, 99.163851017506], [1366016400, 99.480000000000, 99.670050000000, 98.440000000000, 99.669000000000, 3171.192440260000, 315171.219066699197, 99.385712158439], [1366020000, 99.669000000000, 100.900000000000, 95.749910000000, 96.480000000000, 4946.208035740000, 485642.214271231903, 98.184752999087], [1366023600, 96.480000000000, 99.900000000000, 96.000010000000, 97.754020000000, 2165.669793820000, 212939.413728215292, 98.324968255024], [1366027200, 97.754020000000, 98.184560000000, 94.300000000000, 95.751020000000, 4569.546625790000, 437412.496896403688, 95.723390681189], [1366030800, 95.751020000000, 98.227000000000, 95.800000000000, 97.564000000000, 1693.072110810000, 164573.789948878571, 97.204241271297], [1366034400, 97.564000000000, 97.999980000000, 95.251000000000, 96.988800000000, 2441.884874420000, 235956.204271299972, 96.628717734838], [1366038000, 96.988800000000, 97.690000000000, 94.510010000000, 96.209980000000, 2986.833511370000, 286336.131945691717, 95.866117363319], [1366041600, 96.209980000000, 96.209970000000, 92.912000000000, 93.900000000000, 4305.747259710000, 406562.012137355852, 94.423101871692], [1366045200, 93.900000000000, 95.900000000000, 88.010000000000, 89.300000000000, 19429.865548910000, 1773990.696676225246, 91.302263117088], [1366048800, 89.300000000000, 93.009990000000, 88.900000000000, 92.500080000000, 5465.136832540000, 500140.306877155365, 91.514690702576], [1366052400, 92.500080000000, 93.009800000000, 89.000000000000, 89.889000000000, 6639.103638070000, 599836.656255147505, 90.349042424275], [1366056000, 89.889000000000, 89.889000000000, 83.000000000000, 83.000000000000, 23885.539969710000, 2063234.120437549596, 86.380049312429], [1366059600, 83.000000000000, 88.000000000000, 75.000000000000, 75.000000000000, 40656.061357500000, 3259480.187389174836, 80.172059923062], [1366063200, 75.000000000000, 82.999990000000, 71.510000000000, 77.320000000000, 40093.365673640000, 3056998.040893245846, 76.246979756631], [1366066800, 77.320000000000, 83.950000000000, 77.510000000000, 82.386010000000, 21814.121837620000, 1769875.774861433735, 81.134404035883], [1366070400, 82.386010000000, 84.500000000000, 77.511100000000, 78.990000000000, 13894.569109460000, 1124391.767859217913, 80.923111684959], [1366074000, 78.990000000000, 79.500000000000, 72.050000000000, 78.790000000000, 17974.357137410000, 1365168.802735675452, 75.950911195280], [1366077600, 78.790000000000, 78.411520000000, 66.000010000000, 71.500000000000, 32099.685857760000, 2283548.764022760476, 71.139286974384], [1366081200, 71.500000000000, 73.000000000000, 61.110000000000, 61.200000000000, 33831.555415360000, 2253648.684515602042, 66.613806455154], [1366084800, 61.200000000000, 74.000000000000, 55.100000000000, 65.419280000000, 60541.565133820000, 3716472.021642475564, 61.387115008138], [1366088400, 65.419280000000, 69.900000000000, 60.030000000000, 67.999900000000, 26504.686211970000, 1702624.066574102300, 64.238604937913], [1366092000, 67.999900000000, 69.490000000000, 54.975000000000, 54.975000000000, 45644.535508340000, 2719604.856289621748, 59.582266004059], [1366095600, 54.975000000000, 63.000000000000, 50.010000000000, 55.489990000000, 55186.697815540000, 2974888.263535547891, 53.905893653558], [1366099200, 55.489990000000, 61.900000000000, 52.660000000000, 56.555510000000, 18763.890799070000, 1060670.209962707661, 56.527200105816], [1366102800, 56.555510000000, 60.052360000000, 53.611110000000, 58.200000000000, 21108.700448800000, 1191732.898492962016, 56.456952496131], [1366106400, 58.200000000000, 66.750000000000, 55.000000000000, 63.000000000000, 31136.662410530000, 1930220.069427273605, 61.991874529702], [1366110000, 63.000000000000, 64.480000000000, 56.152640000000, 57.500000000000, 15559.495679880000, 926848.923279448184, 59.568056854051], [1366113600, 57.500000000000, 61.800000000000, 56.207350000000, 59.959990000000, 6860.025866280000, 403831.196099389605, 58.867299332557], [1366117200, 59.959990000000, 63.490000000000, 58.300000000000, 63.489990000000, 11368.326344610000, 695199.758985401643, 61.152340099298], [1366120800, 63.489990000000, 65.990000000000, 60.122000000000, 65.900000000000, 16566.819523790000, 1053609.959995234768, 63.597599918454], [1366124400, 65.900000000000, 78.990000000000, 64.257450000000, 71.760250000000, 42223.897614210000, 3072827.988689703506, 72.774617273977], [1366128000, 71.760250000000, 82.390000000000, 71.010000000000, 78.000000000000, 30559.300512410000, 2376544.842251787294, 77.768299745169], [1366131600, 78.000000000000, 79.800000000000, 68.100000000000, 70.500000000000, 35022.355919010000, 2599605.132953091564, 74.227020562658], [1366135200, 70.500000000000, 73.899990000000, 69.100000000000, 70.500000000000, 10606.545020060000, 754804.897630157025, 71.164068620140], [1366138800, 70.500000000000, 71.740000000000, 64.089990000000, 66.217610000000, 18209.141248170000, 1219702.336045955478, 66.982968577309], [1366142400, 66.217610000000, 73.000000000000, 64.256080000000, 69.800000000000, 15074.445483560000, 1038391.615420199506, 68.884233025530], [1366146000, 69.800000000000, 69.880000000000, 66.000000000000, 68.230000000000, 6039.993367710000, 408263.431300932519, 67.593357549616], [1366149600, 68.230000000000, 71.400000000000, 67.500000000000, 70.000000000000, 3740.369534020000, 260028.818662305427, 69.519553161058], [1366153200, 70.000000000000, 70.000000000000, 66.500000000000, 68.355680000000, 3668.063216700000, 249503.980319963331, 68.020632573621], [1366156800, 68.355680000000, 68.800000000000, 63.770600000000, 63.999990000000, 8821.108168530000, 581022.587303076482, 65.867301046814], [1366160400, 63.999990000000, 72.980000000000, 63.300000000000, 70.190000000000, 15452.855959520000, 1037212.213576028802, 67.121069159843], [1366164000, 70.190000000000, 76.000000000000, 70.100000000000, 73.600000000000, 17890.012408350000, 1316652.932823971698, 73.597094444129], [1366167600, 73.600000000000, 77.000000000000, 72.920000000000, 73.500010000000, 6358.501795890000, 475042.083603965985, 74.709750638275], [1366171200, 73.500010000000, 74.900000000000, 72.350000000000, 73.599990000000, 3391.347216220000, 249316.219704301975, 73.515391910295], [1366174800, 73.599990000000, 74.687740000000, 72.700000000000, 73.890000000000, 1845.080725340000, 135571.679930396511, 73.477370430724], [1366178400, 73.890000000000, 76.980000000000, 73.500010000000, 75.469990000000, 4838.594748390000, 364846.994477671851, 75.403503176014], [1366182000, 75.469990000000, 77.620000000000, 75.020000000000, 77.480000000000, 3430.737485900000, 263684.355291275236, 76.859379761638], [1366185600, 77.480000000000, 82.450000000000, 75.000000000000, 80.299970000000, 16720.464325720000, 1316468.019785020472, 78.733939090434], [1366189200, 80.299970000000, 88.000000000000, 76.333560000000, 82.500000000000, 22867.293747880000, 1902987.560708607242, 83.218748212610], [1366192800, 82.500000000000, 86.000000000000, 82.000000000000, 83.989990000000, 8483.337660830000, 716996.157189211842, 84.518167949366], [1366196400, 83.989990000000, 87.000000000000, 82.600000000000, 85.436410000000, 9515.859095180000, 811569.593083359910, 85.286003603651], [1366200000, 85.436410000000, 87.999990000000, 80.749990000000, 86.989990000000, 15692.607429350000, 1324390.171710298263, 84.395800868203], [1366203600, 86.989990000000, 93.440000000000, 85.300000000000, 93.199000000000, 23423.585396810000, 2100309.756631519293, 89.666450334181], [1366207200, 93.199000000000, 98.777990000000, 86.020000000000, 90.999990000000, 44987.419846470000, 4169822.057113767813, 92.688624316403], [1366210800, 90.999990000000, 95.700000000000, 87.500000000000, 90.110000000000, 24832.490982540000, 2273212.554007608562, 91.541865679361], [1366214400, 90.110000000000, 94.983680000000, 87.010210000000, 88.994000000000, 16854.869672130000, 1524797.904301455341, 90.466312345491], [1366218000, 88.994000000000, 90.250000000000, 83.000000000000, 84.000000000000, 18920.539971510000, 1619870.895430086500, 85.614411526798], [1366221600, 84.000000000000, 93.669990000000, 83.380000000000, 89.699890000000, 15599.821616970000, 1395721.292940710949, 89.470336726312], [1366225200, 89.699890000000, 90.360000000000, 86.750000000000, 87.990000000000, 6560.545852850000, 576892.203523640096, 87.933567794977], [1366228800, 87.990000000000, 92.688880000000, 87.047010000000, 91.888000000000, 9548.665301910000, 865345.920060312956, 90.624803854756], [1366232400, 91.888000000000, 93.319550000000, 89.510000000000, 91.900010000000, 14194.406500240000, 1300936.594774886035, 91.651355395021], [1366236000, 91.900010000000, 93.800000000000, 90.990900000000, 92.250000000000, 9242.524237590000, 857576.443759761040, 92.785955623674], [1366239600, 92.250000000000, 94.020000000000, 91.230000000000, 93.070000000000, 8123.875604250000, 753579.949719915025, 92.761138455355], [1366243200, 93.070000000000, 94.870000000000, 93.000000000000, 94.835850000000, 5083.135172900000, 479047.557191624473, 94.242537508268]]";
        JSonStorage.setMapper(new JacksonMapper());
        final ArrayList<Object[]> jackons = JSonStorage.restoreFromString(string, new TypeRef<ArrayList<Object[]>>() {
        });

        JSonStorage.setMapper(new SimpleMapper());

        final ArrayList<Object[]> simple = JSonStorage.restoreFromString(string, new TypeRef<ArrayList<Object[]>>() {
        });

        System.out.println(simple);
        System.out.println(jackons);
        System.out.println("SUCCESS: " + JSonStorage.serializeToJson(simple).equals(JSonStorage.serializeToJson(jackons)));
        System.out.println("SUCCESS: " + EqualsBuilder.reflectionEquals(simple, jackons));

    }
}
